#include <htc.h>
#include <math.h>

#include "defines.h"
#include "protos.h"
#include "globals.h"

//________________________________________________________________

void transmit(unsigned char raw_data_to_send){
	while (TRMT != 1)
		continue;

	TXREG =raw_data_to_send;
}
//_____________________________________________________________

void print_plus(signed int cardinal)	{ //modifies temporary!
unsigned char temp;

	char transient = -1;	//-1 because we ALWAYS increment once.

	while (temporary >= 0)	{	//no borrow yet
		temporary = (temporary - cardinal);
		++transient;
	}	//end of while(temporary>=0)
	temporary = (temporary + cardinal);	//temporary changed

	temp = transient + 0x30;
	if(transient != 0)	{
		flags.leading_zero = 0;		//print following characters, including zeros
		transmit(temp);	//send ASCII version of this decade
	}	//end of not 0

	else if(flags.leading_zero == 0)	//it is zero and not leading so send it out.
		transmit(temp);	//send ASCII version of this decade
}
//_____________________________________________________________

void print_fixed_int(void)	{
	print_plus(1000);
	print_plus(100);
	print_plus(10);
	print_plus(1);
}
//________________________________________________________________

void send_acc_and_mag_values(void)	{
//the x accelerations:
	temporary = x_acc;
	if(temporary < 0)	{
		temporary = -temporary;
		transmit('-');	//the minus sign
	}
	else
		transmit('+');	//so the strings are fixed length
	print_fixed_int();
	transmit(',');

//the y accelerations:
	temporary = y_acc;
	if(temporary < 0)	{
		temporary = -temporary;
		transmit('-');	//the minus sign
	}
	else
		transmit('+');	//so the strings are constant length
	print_fixed_int();
	transmit(',');

//the z accelerations:
	temporary = z_acc;
	if(temporary < 0)	{
		temporary = -temporary;
		transmit('-');	//the minus sign
	}
	else
		transmit('+');	//so the strings are constant length
	print_fixed_int();
	transmit(',');

//the x magnetometer:
	temporary = x_mag;
	if(temporary < 0)	{
		temporary = -temporary;
		transmit('-');	//the minus sign
	}
	else
		transmit('+');	//so the strings are constant length
	print_fixed_int();
	transmit(',');

//the y magnetometer:
	temporary = y_mag;
	if(temporary < 0)	{
		temporary = -temporary;
		transmit('-');	//the minus sign
	}
	else
		transmit('+');	//so the strings are constant length
	print_fixed_int();
	transmit(',');

//the z magnetometer:
	temporary = z_mag;
	if(temporary < 0)	{
		temporary = -temporary;
		transmit('-');	//the minus sign
	}
	else
		transmit('+');	//so the strings are constant length
	print_fixed_int();

	transmit(0x0D);	//CR
	transmit(0x0A);	//LF
}
//________________________________________________________________
