#include <htc.h>

#include "defines.h"
#include "globals.h"
#include "protos.h"

//_____________________________________________________________

void write_to_EE(unsigned char value, unsigned char address)	{
//unsigned int safety = 0;	//to stop lock-up in here
//see page 43 of PIC16F87X data sheet:

	while(WR != 0)
		CLRWDT();	//do nothing until all clear to do so.
	
	EEADR = address;
	EEDAT = value;
	EECON1 = 0;			//a good default value
	WREN = 1;			//enable writes

	while (GIE != 0)
		GIE = 0;	//keep trying
	EECON2 = 0x55;
	EECON2 = 0xAA;
	WR = 1;
	GIE = 1;
	while(WR != 0)
		CLRWDT();	//do nothing until all clear to do so.

	WREN = 0;
	EEADR = 0;
}
//_____________________________________________________________

unsigned char read_from_EE(unsigned char address)	{
	//see page 43 of PIC16F87X data sheet:
	EEADR = address;
	RD = 1;   		//force a read...immediately!
	EEADR = 0;   	//play safe.
	return(EEDAT);
}

//_____________________________________________________________
