typedef struct	{
	unsigned leading_zero	: 1;	//the latest
	unsigned shutdown		: 1;
	unsigned got_mag		: 1;	//from the controller
	unsigned got_acc		: 1;	//set by ISR when a frame's arrived.
	unsigned bit_value		: 1;
	unsigned T6_timeout		: 1;
} FLAG_BITS;

extern volatile FLAG_BITS flags;

extern unsigned char state;
extern signed int tick_count;

extern signed int temporary;
extern double angle_xy;
extern double angle_yz;
extern double angle_zx;

extern double pitch_COS;	//this is the COS(x/z)
extern double pitch_SIN;	//this is the SIN(x/z)

extern double roll_COS;	//this is COS(y/z)
extern double roll_SIN;	//this is SIN(y/z

extern double x_acc_value;
extern double y_acc_value;
extern double z_acc_value;

extern double x_mag_value;
extern double y_mag_value;
extern double z_mag_value;

extern double x_heading;
extern double y_heading;
extern double compensated_heading;

extern unsigned char checksum;

extern signed int x_acc;
extern signed int y_acc;
extern signed int z_acc;

extern signed int x_mag;
extern signed int y_mag;
extern signed int z_mag;

extern unsigned char mx[2];
extern unsigned char my[2];
extern unsigned char mz[2];

extern unsigned char ax[2];
extern unsigned char ay[2];
extern unsigned char az[2];

extern double angle;

extern double Mx1;	//as for page 22 of AN3192
extern double My1;
extern double Mz1;

extern double Mx2;	//as for page 22 of AN3192
extern double My2;
extern double Mz2;

extern double x_acc_ave;
extern double y_acc_ave;
extern double z_acc_ave;

extern double x_mag_ave;
extern double y_mag_ave;
extern double z_mag_ave;

extern unsigned char CTRLS[];

//_______________________________________________________________


