#include <htc.h>
#include "defines.h"
#include "globals.h"
#include "protos.h"

//_________________________________________________________________

//these for HS external oscillator; MCLR is NOT digital input; no brown-out protection; :

__CONFIG(FOSC_HS & WDTE_OFF & PWRTE_ON & MCLRE_ON & CP_OFF & CPD_OFF & BOREN_OFF & FCMEN_OFF);
__CONFIG(PLLEN_OFF & STVREN_OFF & BORV_HI & LVP_OFF);

//_________________________________________________________________

void main(void)	{

	setup();
	configure();	//configure the sensors

	state = 0;	//wait for an input and rotate the display

	while(1)	{	//forever:
		switch(state)	{
			case 0:	//is start tick counter.
			tick_count = TICK_COUNT;
			state = 1;
			break;

			case 1:	//is wait a while.
			tick_count--;
			start_timer_6(5);	//waits here (n)mS
			if(tick_count <= 0)	{	//send the six values
				state = 2;
			}
			break;

			case 2:
			read_accelerometers();
			read_magnetics();
			send_acc_and_mag_values();
			state = 0;	//and start again, every 2 seconds or so.
			break;
		}	//end of switch

	}	//end of while(1)
}
//_________________________________________________________________
